// =================================================================================================
// -------------------------------------------------------------------------------------------------
// .eno extractor
// -------------------------------------------------------------------------------------------------

#include <stdio.h>
#include <windows.h>
#include <dirent.h>

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Subroutine to dump buffer contents to a file
// -------------------------------------------------------------------------------------------------

void DumpBuffer (char *Buffer, int Size, const char *Filename)

{
	FILE *File;
	if ((File = fopen (Filename, "wb")) != NULL)
	{
		int Counter = 0x00;
		while (Counter != Size)
		{
			fputc (Buffer [Counter++], File);
		}
		fclose (File);
	}
}

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Subroutine to reallocate a Memory space (For char)
// -------------------------------------------------------------------------------------------------

int AllocChar (char *&MemoryOld, int &MemorySize, int NewSize)

{
	char *Memory = (char*) malloc (NewSize + 0x01);
	if (Memory == NULL)
	{
		MessageBox (NULL, "Could not reallocate memory", "Error", MB_ICONEXCLAMATION | MB_OK);
		return (0x01);
	}
	else
	{
		if (NewSize > MemorySize)
		{
			memcpy (Memory, MemoryOld, MemorySize);
		}
		else
		{
			memcpy (Memory, MemoryOld, NewSize);
		}
	}
	free (MemoryOld);
	MemorySize = NewSize;
	MemoryOld = Memory;
	return (0x00);
}

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Subroutine to compact a folder of files into a .one file
// -------------------------------------------------------------------------------------------------

void CompactFile (char *FolderString)

{
	int i0, i1, i2, i3, i4, i5, i6, i7, Fail = 0x00;
	char Folder [0x0400];
	int FolderLoc;
	for (FolderLoc = -0x01, i0 = ' '; i0 != 0x00; )
	{
		i0 = FolderString [++FolderLoc];
		Folder [FolderLoc] = i0;
	}
	Folder [FolderLoc] = '/';
	char ListName [] = "00_OrderList.txt";
	for (i0 = ' ', i1 = 0x00, i2 = FolderLoc + 0x01; i0 != 0x00; )
	{
		i0 = ListName [i1++];
		Folder [i2++] = i0;
	}
	FILE *List;
	if ((List = fopen (Folder, "rb")) == NULL)
	{
		printf ("    Error: Could not open \"%s\"\n", ListName);
	}
	else
	{
		fseek (List, 0x00, SEEK_END);
		i0 = ftell (List);
		rewind (List);
		for (i7 = 0x00; i0 != 0x00; i0--)
		{
			i1 = fgetc (List);
			if (i1 == 0x0A)
			{
				i7++;
			}
		}
		rewind (List);
		printf ("    Total files to process: %8X\n", i7);
		char *Memory = NULL; int MemorySize, MemoryLoc = 0x00;
		AllocChar (Memory, MemorySize = 0x00, (i7 * 0x40) + 0x20);
		Memory [MemoryLoc++] = 'o';
		Memory [MemoryLoc++] = 'n';
		Memory [MemoryLoc++] = 'e';
		Memory [MemoryLoc++] = '.';
		Memory [MemoryLoc++] = i7;
		Memory [MemoryLoc++] = i7 >> 0x08;
		Memory [MemoryLoc++] = i7 >> 0x10;
		Memory [MemoryLoc++] = i7 >> 0x18;
		printf ("    Compacting files...\n\n");
		for ( ; i7 > 0x00 && Fail == 0x00; i7--)
		{
			char StringDisplay [0x0400];
			for (i6 = MemoryLoc, i5 = FolderLoc + 0x01, i4 = 0x00, i0 = ' '; i0 != 0x00; )
			{
				i0 = fgetc (List) & 0xFF;
				if (i0 == 0x0D || i0 == 0x0A)
				{
					if (i0 == 0x0D)
					{
						fgetc (List); // quicker than seeking
					}
					i0 = 0x00;
				}
				Memory [i6++] = i0;
				Folder [i5++] = i0;
				StringDisplay [i4++] = i0;
			}
			printf ("      %s\n", StringDisplay);
			MemoryLoc += 0x38;
			while (i6 < MemoryLoc)
			{
				Memory [i6++] = i0;
			}
			Memory [MemoryLoc++] = MemorySize;
			Memory [MemoryLoc++] = MemorySize >> 0x08;
			Memory [MemoryLoc++] = MemorySize >> 0x10;
			Memory [MemoryLoc++] = MemorySize >> 0x18;
			FILE *File;
			if ((File = fopen (Folder, "rb")) == NULL)
			{
				printf ("      Error: Could not open the file, Halting process...\n");
				Fail = 0x01;
			}
			else
			{
				fseek (File, 0x00, SEEK_END);
				i6 = ftell (File);
				rewind (File);
				Memory [MemoryLoc++] = i6;
				Memory [MemoryLoc++] = i6 >> 0x08;
				Memory [MemoryLoc++] = i6 >> 0x10;
				Memory [MemoryLoc++] = i6 >> 0x18;
				i5 = MemorySize;
				i0 = MemorySize + i6;
				i0 += 0x20 - (i0 & 0x0000001F); // .one files seem to be padded this way, though they might not need padding if the last file ends at a 20th, so let's play it safe and do it their way.
				AllocChar (Memory, MemorySize, i0);
				while (i6 != 0x00)
				{
					Memory [i5++] = fgetc (File);
					i6--;
				}	
				fclose (File);
			}
		}
		if (Fail == 0x00)
		{
			for (i0 = 0x18; i0 != 0x00; i0--)
			{
				Memory [MemoryLoc++] = 0x00;
			}
			Folder [FolderLoc++] = '.';
			Folder [FolderLoc++] = 'o';
			Folder [FolderLoc++] = 'n';
			Folder [FolderLoc++] = 'e';
			Folder [FolderLoc++] = 0x00;
			DumpBuffer (Memory, MemorySize, Folder);
		}
		free (Memory);
		fclose (List);
	}
}

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Main routine
// -------------------------------------------------------------------------------------------------

int main (int ArgCount, char **ArgList, char **EnvList)

{
	printf (".one compactor - by MarkeyJester\n");
	if (ArgCount <= 0x01)
	{
		printf ("\n -> Drag and drop a folder of files onto this application\n");
	}
	else
	{
		int i0, i1, i2, i3, i4, i5, i6, i7;
		for (i7 = 0x01; i7 < ArgCount; i7++)
		{
			char *Filename = ArgList [i7];
			printf ("\n -> %s\n\n", Filename);
			CompactFile (Filename);
		}
	}
	printf ("\nPress enter key to exit...\n");
	fflush (stdin);
	getc (stdin);
	return (0x00);
}

// =================================================================================================
