// =================================================================================================
// -------------------------------------------------------------------------------------------------
// .eno extractor
// -------------------------------------------------------------------------------------------------

#include <stdio.h>
#include <windows.h>
#include <direct.h>

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Subroutine to reallocate a Memory space (For char)
// -------------------------------------------------------------------------------------------------

int AllocChar (char *&MemoryOld, int &MemorySize, int NewSize)

{
	char *Memory = (char*) malloc (NewSize + 0x01);
	if (Memory == NULL)
	{
		MessageBox (NULL, "Could not reallocate memory", "Error", MB_ICONEXCLAMATION | MB_OK);
		return (0x01);
	}
	else
	{
		if (NewSize > MemorySize)
		{
			memcpy (Memory, MemoryOld, MemorySize);
		}
		else
		{
			memcpy (Memory, MemoryOld, NewSize);
		}
	}
	free (MemoryOld);
	MemorySize = NewSize;
	MemoryOld = Memory;
	return (0x00);
}

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Subroutine to extract a .one file
// -------------------------------------------------------------------------------------------------

void ExtractFile (char *Filename)

{
	int i0, i1, i2, i3, i4, i5, i6, i7;
	FILE *File, *List;
	if ((File = fopen (Filename, "rb")) == NULL)
	{
		printf ("    Error: Could not open file\n");
	}
	else
	{
		i0 = (fgetc (File) & 0xFF) << 0x18;
		i0 |= (fgetc (File) & 0xFF) << 0x10;
		i0 |= (fgetc (File) & 0xFF) << 0x08;
		i0 |= fgetc (File) & 0xFF;
		if (i0 != 0x6F6E652E) // "one."
		{
			fclose (File);
			printf ("    Error: Doesn't appear to be a valid .one file\n");
		}
		else
		{
			char *Memory = NULL; int MemorySize, MemoryLoc;
			fseek (File, 0x00, SEEK_END);
			AllocChar (Memory, MemorySize = 0x00, ftell (File));
			rewind (File);
			fread (Memory, MemorySize, 0x01, File);
			fclose (File);
			char NewFile [0x0400];
			int NewFileLoc = 0x00;
			char FileString [0x0400];
			for (i1 = -0x01, i0 = ' '; i0 != 0x00; )
			{
				i0 = Filename [++i1];
				if (i0 == '.')
				{
					NewFileLoc = i1;
				}
				NewFile [i1] = i0;
			}
			if (NewFileLoc == 0x00)
			{
				NewFileLoc = i1;
			}
			else
			{
				NewFile [NewFileLoc] = 0x00;
			}
			mkdir (NewFile);
			NewFile [NewFileLoc++] = '/';

			char ListName [] = "00_OrderList.txt";
			for (i2 = NewFileLoc, i1 = 0x00, i0 = ' '; i0 != 0x00; )
			{
				i0 = ListName [i1++] & 0xFF;
				NewFile [i2++] = i0;
			}
			List = fopen (NewFile, "wb");
			MemoryLoc = 0x04;
			i7 = Memory [MemoryLoc++] & 0xFF;
			i7 |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
			i7 |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
			i7 |= (Memory [MemoryLoc++] & 0xFF) << 0x18;

			while (i7 != 0x00)
			{
				for (i0 = ' ', i1 = MemoryLoc, i2 = NewFileLoc, i3 = 0x00; i0 != 0x00; )
				{
					i0 = Memory [i1++] & 0xFF;
					NewFile [i2++] = i0;
					FileString [i3++] = i0;
				}
				fputs (FileString, List); fputc (0x0D, List); fputc (0x0A, List);
				FILE *Output = fopen (NewFile, "wb");
				MemoryLoc += 0x38;

				// Offset
				i0 = Memory [MemoryLoc++] & 0xFF;
				i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
				i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
				i0 |= (Memory [MemoryLoc++] & 0xFF) << 0x18;

				// Size
				i1 = Memory [MemoryLoc++] & 0xFF;
				i1 |= (Memory [MemoryLoc++] & 0xFF) << 0x08;
				i1 |= (Memory [MemoryLoc++] & 0xFF) << 0x10;
				i1 |= (Memory [MemoryLoc++] & 0xFF) << 0x18;

				while (i1 != 0x00)
				{
					fputc (Memory [i0++], Output);
					i1--;
				}
				fclose (Output);
				i7--;
			}
			free (Memory);
			fclose (List);
		}
	}
}

// =================================================================================================
// -------------------------------------------------------------------------------------------------
// Main routine
// -------------------------------------------------------------------------------------------------

int main (int ArgCount, char **ArgList, char **EnvList)

{
	printf (".one extractor - by MarkeyJester\n");
	if (ArgCount <= 0x01)
	{
		printf ("\n -> Drag and drop .one bin files onto this application\n");
	}
	else
	{
		int i0, i1, i2, i3, i4, i5, i6, i7;
		for (i7 = 0x01; i7 < ArgCount; i7++)
		{
			char *Filename = ArgList [i7];
			printf ("\n -> %s\n", Filename);
			ExtractFile (Filename);
		}
	}
	printf ("\nPress enter key to exit...\n");
	fflush (stdin);
	getc (stdin);
	return (0x00);
}

// =================================================================================================
